#!/bin/sh
#
# Torneo shell ver.2.1 (C) 2003 Maurizio Camangi - all rights reserved
#

TXP=/home/mcamangi/bin/txp
COUNT=/home/mcamangi/bin/count
CROBOTS_HOME=/home/mcamangi/crobots
ROB=$1
DESCR=$2
RCPT=crobots@ioprogrammo.it
RCPT2=crobots@yahoogroups.com
RCPT3=camangi@edmaster.it
FTP_HOST=www.ioprogrammo.net
FTP_AUTO=auto_$ROB"_total"
F2F=5000

echo $$ > `basename $0`.pid

(for i in `find torneo2003/ -name "*.[r|R]"` ; do crobots -c $i </dev/null 2>/dev/null | grep compile ; done) > log

grep -q -s "could not compile" log
E=$?
if [ $E -eq 0 ] ;
then
	cat log | mail -s "Errore compilazione robots torneo Crobots" $RCPT3 ;
	exit ;
fi

sed s/fuffo/$ROB/g auto >auto_$ROB"_f2f"
sed s/fuffo/$ROB"4"/g auto >auto_$ROB"_4vs4"
sed s/fuffo/$ROB"T"/g auto >auto_$ROB"_total"

cat $ROB.rob | grep "\.[r|R]" | xargs ls 2>log
E=$?
if [ ! $E -eq 0 ] ;
then
	cat log | mail -s "Errore controllo robots torneo Crobots" $RCPT3 ;
	exit ;
fi


$TXP -q -a=$F2F $ROB.rob >log 2>&1
E=$?
if [ ! $E -eq 0 ] ;
then
	cat log $1.msg | mail -s "Errore gestione torneo Crobots" $RCPT3 ;
	exit ;
fi

cat $ROB"T".txt | mail -s "Torneo 2003: $DESCR Total `head -n1 $ROB"T".txt | cut -d " " -f 11-11`" $RCPT -c $RCPT2
ftp -i -n -p $FTP_HOST <$FTP_AUTO
